/*
 *test
 * COMPONENT_NAME: <FILL_ME_IN>
 *
 * ORIGINS: Transarc Corp.
 *
 * (C) COPYRIGHT Transarc Corp. 1998
 * All Rights Reserved
 * Licensed Materials - Property of Transarc
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with Transarc Corp
 */

package com.ibm.ejs.sm.client.ui.editor;

import java.awt.*;
import java.awt.event.*;
import java.text.*;
import java.util.*;
import java.rmi.*;
import java.beans.*;
import java.io.*;
import com.ibm.ejs.sm.exception.*;

import com.sun.java.swing.*;     
import com.sun.java.swing.event.*;     
import com.sun.java.swing.tree.*;     
import com.sun.java.swing.border.*;     
import com.sun.java.swing.text.*;     
import com.sun.java.swing.preview.*;
import com.sun.java.swing.preview.filechooser.*;


import com.ibm.ejs.sm.beans.*;
import com.ibm.ejs.sm.client.ui.fs.*;
import com.ibm.ejs.sm.client.ui.*;
import com.ibm.ejs.ras.*;
import com.ibm.ejs.sm.beans.*;
import com.ibm.ejs.sm.client.*;
import com.ibm.ejs.sm.exception.*;
import com.ibm.ejs.sm.client.command.*;
import com.ibm.ejs.sm.client.util.Utils;
import com.ibm.ejs.sm.client.util.OrbHelper;


import java.util.Vector;

public class ServletGroupPropertySheet extends LiveROPropertySheet implements ActionListener, PropertyChangeListener
{
    private static TraceComponent tc = Tr.register(ServletGroupPropertySheet.class); 

    private TypeInstance servletGroup;
    private TypeInstance ti;
    private TypeObject   ejbType;
    private ServletGroupHome servletGroupHome;
    private ServletGroupAttributes cattrs;
    private ModelAttributes mattrs = null;
    private ServletGroupAttributes initialAttributes;
    //    private ActionListener actionListener;
    private RepositoryObjectProxy ro[];

    private RepositoryObjectProxy vhro[];
    private String vh[];

    private JComboBox engineListComboBox;
    private JComboBox autoReloadComboBox;

    private String boolStrings[];

    private String server_root=null;
    private String defaultVHName="default_host";
    private boolean docRootEdited =false;
    private String slash = "/";

    private GridBagLayout gbl;
    private GridBagConstraints gbc;

    private JLabel engineNameL;
    private JLabel descriptionL ;
    private JTextField descriptionT;
    private JLabel attributesL ;
    private PropertyEditor attributesPE;
    private JLabel  docRootL;
    private JTextField docRootT;

    private JComboBox sharedContextComboBox;
    private JTextField sharedContextDataSourceT;
    private JPanel sharedContextPanel;
    private JLabel  sharedContextL;
    private JLabel  sharedContextDataSourceL;

    private ClassPathPanel  classPathPanel;
    private VectorEditor classPathVE;
    private JPanel movementButtonPanel;
    private JButton upButton;
    private JButton downButton;
    private JButton browseButton;
    private JButton deleteButton;

    protected JLabel enabledL; 
    protected JLabel enabledStringL;

    private JLabel  reloadIntervalL;
    private JTextField reloadIntervalT;

    private JLabel  uriL;
    private JTextField uriT;
    private boolean uriEdited =false;


    private JLabel  errorPageL;
    private JTextField errorPageT;
    private JLabel filterListL;
    private PropertyEditor filterListPE;


    private JLabel  uriActiveL;
    private JLabel uriActiveT;
    private JLabel  errorPageActiveL;
    private JLabel errorPageActiveT;
    private JLabel  docRootActiveL;
    private JLabel docRootActiveT;
    private JLabel filterListActiveL;
    private PropertyEditor filterListActivePE;
    private JLabel attributesActiveL;
    private PropertyEditor attributesActivePE;
    private JLabel autoReloadActiveL;
    private JLabel autoReloadActiveT;
    private JLabel reloadIntervalActiveL;
    private JLabel reloadIntervalActiveT;
    private JLabel classPathActiveL;
    private VectorEditor classPathActiveVE;
    private JLabel sharedContextActiveL;
    private JLabel sharedContextActiveT;
    private JLabel sharedContextDataSourceActiveL;
    private JLabel sharedContextDataSourceActiveT;
    private JLabel virtualHostActiveL;
    private JLabel virtualHostActiveT;

    private JLabel autoReloadL;

    private JLabel virtualHostL;
    private JComboBox virtualHostComboBox;

    private String selectedVirtualHost;

    private String name;

    private boolean dirtyURI = false;
    private String initialURI;

    private FileBrowserService fsService;
    private JFileChooser chooser;
    private static String lastUsedDir;

    private static final String servletGroupTypeName = "com.ibm.ejs.sm.beans.ServletGroup";

    //    Dimension minimumSize   = new Dimension(400,400);
    Dimension preferredSize = new Dimension(400,400);

    private final static int FIELD_SIZE = 15;

    TypeObject to;

    public ServletGroupPropertySheet(Integer mode, TypeInstance ejb) {
        this(mode.intValue(), ejb);
    }
    public ServletGroupPropertySheet(Integer mode, TypeObject ejbType) {
        this(mode.intValue(), ejbType);
    }

    public ServletGroupPropertySheet(int mode) {
        this(mode,TypeObject.findTypeObject(servletGroupTypeName));
    }

    public ServletGroupPropertySheet(int mode, TypeObject ejbType) {
        super(mode,ejbType);
        to = TypeObject.findTypeObject(servletGroupTypeName);
        Tr.entry(tc, "ServletGroupPropertySheet, mode: " + mode + " group type: " + ejbType);
        this.ejbType = ejbType;
        postInit();
        notSetString = labelNLS.getString("propertySheet.attributeNotSet",
                                          "Attribute not set");
        Tr.exit(tc, "ServletGroupPropertySheet");
    }

    public ServletGroupPropertySheet(int mode, TypeInstance servletGroup)  {
        super(mode,servletGroup);
        to = TypeObject.findTypeObject(servletGroupTypeName);
        Tr.entry(tc, "ServletGroupPropertySheet, mode: " + mode + " group proxy: ", servletGroup);
        if (modeBits.get(MODEL_MODE) && (servletGroup.getREJB() instanceof Model))
        {
            try
            {
                mattrs = (ModelAttributes) servletGroup.getAttributes();
                liveAttributes = cattrs = (ServletGroupAttributes)
                                 mattrs.getAttributes();
                Tr.event(tc, "ServletGroupAttributes initialized", cattrs);
                ejbType = TypeObject.findTypeObject(servletGroupTypeName);
            }
            catch (Exception e)
            {
                Tr.warning(tc, "Error.in.getting.model.servletGroup.attrs", e);
            }
        }
        else
        {
            this.servletGroup = servletGroup;
            this.ejbType      = servletGroup.getTypeObject();
        }
        notSetString = labelNLS.getString("propertySheet.attributeNotSet",
                                          "Attribute not set");
        postInit();
        Tr.exit(tc, "ServletGroupPropertySheet");
    }


    private void setInitialAttributes(ServletGroupAttributes cattrs) {
        initialAttributes = cattrs;
    }

    public void setName (String name) {
        if (nameTextField != null)
        {
            nameTextField.setText(name);
        }
    }

    public void propertyChange(PropertyChangeEvent e) {
        if (e.getPropertyName().equals("ParentSelection"))
        {
            if (isValidParentSelected())
            {
                setServerRoot(getParentSelection());
            }
        }
    }

    protected void postInit() {
        Tr.entry(tc, "postInit");

        addPropertyChangeListener(this);

        if (cattrs == null)
        {
            liveAttributes = cattrs = (ServletGroupAttributes)getInitialAttributes(servletGroup,ejbType);
            Tr.event(tc, "ServletGroup initialized", cattrs);
        }
        setInitialAttributes(cattrs);
        createComponents();
        super.postInit();
        if (isValidParentSelected())
            setServerRoot(getParentSelection());
        Tr.exit(tc, "postInit");
    }

    protected  void createComponents() {
        Tr.entry(tc, "createComponents");
        super.createComponents();

        /*
        ** setup Props
          ** enabled
        ** Pick Connecting ServletEngine
        ** Group Name (done by BasePropSheet)
        ** Description
        ** DocRoot
        ** Classpath
        ** Pick URI
        */
        enabledL = getLabel(labelNLS.getString("any.enabled.label","Enabled"));
        enabledStringL = new JLabel();

        engineNameL = getRequiredLabel(labelNLS.getString("servletgroup.appenginename.label", "Servlet Engine"));
        engineListComboBox = new JComboBox();

        descriptionL = getLabel(labelNLS.getString("servletgroup.description.label", "Description"));
        descriptionT = new JTextField(FIELD_SIZE);

        virtualHostL = getRequiredLabel(labelNLS.getString("servletgroup.virtualhost.label", "Virtual Host"));
        virtualHostComboBox = new JComboBox();
        virtualHostComboBox.setActionCommand("VirtualHost");
        virtualHostComboBox.addActionListener(this);

        virtualHostActiveL = getRequiredLabel(labelNLS.getString("servletgroup.activevirtualhost.label", "Virtual Host in use"));
        virtualHostActiveT = new JLabel();
        virtualHostActiveT.setForeground(UIConstants.activeAttrColor);

        uriL = getRequiredLabel(labelNLS.getString("servletgroup.uriname.label", "Web Application Web Path"));
        uriT = new  JTextField(FIELD_SIZE);
        uriT.addKeyListener(new KeyAdapter() {
                                public void keyReleased(KeyEvent e) {
                                    uriEdited = true;
                                    dirtyURI =true;
                                }
                            });

        uriActiveL = getRequiredLabel(labelNLS.getString("servletgroup.activeuriname.label", "Web Application Web Path in use"));
        uriActiveT = new JLabel();
        uriActiveT.setForeground(UIConstants.activeAttrColor);

        /*
        ** create Advanced Props
        ** ErrorPage
        ** Init Params
        ** FilterList
        ** Attributes
        ** GroupAutoReload
        */
        errorPageL = getLabel(labelNLS.getString("servletgroup.errorpage.label", "Error Page"));
        errorPageT = new JTextField(FIELD_SIZE);

        docRootL = getLabel(labelNLS.getString("servletgroup.docroot.label", "Document Root"));
        docRootT = new JTextField(FIELD_SIZE);
        docRootT.addKeyListener(new KeyAdapter() {
                                    public void keyReleased(KeyEvent e) {
                                        docRootEdited = true;
                                    }
                                });

        classPathVE = new VectorEditor(labelNLS.getString("servletgroup.classpath.label", "Classpath"), new Vector());
        classPathPanel = new ClassPathPanel();
        movementButtonPanel = new JPanel();

        upButton = new JButton(){
            public Dimension getPreferredSize() { return new Dimension(20,20);}
            public Dimension getMaximumSize()   { return new Dimension(20,20);}
        };
        upButton.setIcon(UIConstants.UpIcon);
        upButton.setActionCommand("Up");
        upButton.addActionListener(classPathPanel);

        downButton = new JButton(){
            public Dimension getPreferredSize() { return new Dimension(20,20);}
            public Dimension getMaximumSize()   { return new Dimension(20,20);}
        };
        downButton.setIcon(UIConstants.DownIcon);
        downButton.setActionCommand("Down");
        downButton.addActionListener(classPathPanel);


        deleteButton = new JButton(){
            public Dimension getPreferredSize() { return new Dimension(20,20);}
            public Dimension getMaximumSize()   { return new Dimension(20,20);}
        };
        deleteButton.setIcon(UIConstants.DeleteIcon);
        deleteButton.setActionCommand("Delete");
        deleteButton.addActionListener(classPathPanel);


        browseButton = new JButton(){
            public Dimension getPreferredSize() { return new Dimension(20,20);}
            public Dimension getMaximumSize()   { return new Dimension(20,20);}
        };
        browseButton.setIcon(UIConstants.BrowseIcon);
        browseButton.setActionCommand("Browse");
        browseButton.addActionListener(classPathPanel);

        movementButtonPanel.setLayout(new GridLayout(4,1));
        movementButtonPanel.add(browseButton);
        movementButtonPanel.add(upButton);
        movementButtonPanel.add(downButton);
        movementButtonPanel.add(deleteButton);

        classPathPanel.setLayout(new BorderLayout());
        JScrollPane scrollbar = new JScrollPane(classPathVE);
        classPathPanel.add(scrollbar,BorderLayout.CENTER);
        classPathPanel.add(movementButtonPanel,BorderLayout.EAST);
        classPathPanel.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(),labelNLS.getString("servletgroup.classpath.label","Classpath for Application")));
        Vector v = new Vector();
        Properties p = new Properties();

        filterListL = getLabel(labelNLS.getString("servletgroup.filterlist.label", "Filter List"));
        v = new Vector();
        v.addElement(labelNLS.getString("servletgroup.filterlist.name", "Mime Type"));
        v.addElement(labelNLS.getString("servletgroup.filterlist.value", "Servlet URI"));
        p = new Properties();
        filterListPE = new PropertyEditor(v,p);

        attributesL = getLabel(labelNLS.getString("servletgroup.attributes.label", "Attributes"));
        v = new Vector();
        v.addElement(labelNLS.getString("servletgroup.attributes.name", "Attribute Name"));
        v.addElement(labelNLS.getString("servletgroup.attributes.value", "Attribute Value"));
        p = new Properties();
        attributesPE = new PropertyEditor(v,p);

        reloadIntervalL = getLabel(labelNLS.getString("servletgroup.reloadinterval.label", "Reload Interval"));
        reloadIntervalT = new JTextField(FIELD_SIZE);
        reloadIntervalActiveL = getLabel(labelNLS.getString("servletgroup.reloadinterval.activelabel", "Reload Interval in use"));
        reloadIntervalActiveT = new JLabel();
        reloadIntervalActiveT.setForeground(UIConstants.activeAttrColor);

        autoReloadL = getLabel(labelNLS.getString("servletgroup.autoreload.label", "Auto Reload"));
        boolStrings = new String[2];
        boolStrings[0]=labelNLS.getString("any.true.label", "True");
        boolStrings[1]=labelNLS.getString("any.false.label","False");
        autoReloadComboBox = new JComboBox(boolStrings);

        sharedContextPanel = new JPanel();
        sharedContextPanel.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(),labelNLS.getString("servletgroup.sharedcontext.label","Set up Shared Context")));
        sharedContextL = getLabel(labelNLS.getString("servletgroup.usesharedcontext.label", "Use Shared Context"));
        sharedContextComboBox = new JComboBox(boolStrings);
        sharedContextComboBox.setActionCommand("SharedContext");
        sharedContextComboBox.addActionListener(this);

        sharedContextDataSourceL = getLabel(labelNLS.getString("servletgroup.sharedcontextdatasource.label", "Shared Context JNDI Name "));
        sharedContextDataSourceT = new JTextField();

        errorPageActiveL = getLabel(labelNLS.getString("servletgroup.activeerrorpage.label", "Error Page in use"));
        errorPageActiveT = new JLabel();
        errorPageActiveT.setForeground(UIConstants.activeAttrColor);

        autoReloadActiveL = getLabel(labelNLS.getString("servletgroup.activeautoreload.label", "Auto Reload in use"));
        autoReloadActiveT = new JLabel();
        autoReloadActiveT.setForeground(UIConstants.activeAttrColor);

        docRootActiveL = getLabel(labelNLS.getString("servletgroup.activedocroot.label", "Document Root in use"));
        docRootActiveT = new JLabel();
        docRootActiveT.setForeground(UIConstants.activeAttrColor);

        classPathActiveVE = new ImmutableVectorEditor(labelNLS.getString("servletgroup.activeclasspath.label", "Classpath"), new Vector());

        sharedContextActiveL = getLabel(labelNLS.getString("servletgroup.activesharedcontext.label", "Shared Context in use"));
        sharedContextActiveT = new JLabel();
        sharedContextActiveT.setForeground(UIConstants.activeAttrColor);

        sharedContextDataSourceActiveL = getLabel(labelNLS.getString("servletgroup.activesharedcontextdatasource.label", "Shared Context Data Source in use"));
        sharedContextDataSourceActiveT = new JLabel();
        sharedContextDataSourceActiveT.setForeground(UIConstants.activeAttrColor);


        filterListActiveL = getLabel(labelNLS.getString("servletgroup.activefilterlist.label", "Filter List in use"));
        v = new Vector();
        v.addElement(labelNLS.getString("servletgroup.filterlist.name", "Mime Type"));
        v.addElement(labelNLS.getString("servletgroup.filterlist.value", "Servlet URI"));
        p = new Properties();
        filterListActivePE = new ImmutablePropertyEditor(v,p);

        attributesActiveL = getLabel(labelNLS.getString("servletgroup.activeattributes.label", "Attributes in use"));
        v = new Vector();
        v.addElement(labelNLS.getString("servletgroup.attributes.name", "Attribute Name"));
        v.addElement(labelNLS.getString("servletgroup.attributes.value", "Attribute Value"));
        p = new Properties();
        attributesActivePE = new ImmutablePropertyEditor(v,p);

        if (modeBits.get(BasePropertySheet.CREATE_MODE)&& !modeBits.get(BasePropertySheet.MODEL_MODE))
        {
            // App Server Choices
            ro = Utils.getAllObjectsOfType("com.ibm.ejs.sm.beans.ServletEngine");
            if (ro == null || ro.length == 0)
            {
                showError("No ServletEngines found to create Web Application under");
                return;
            }

            for (int i = 0 ;i < ro.length; i++)
            {
                engineListComboBox.addItem(ro[i]);
            }

            RepositoryObjectProxy rop = SelectionCoordinator.getSelectedProxy();
            if (rop instanceof TypeInstance)
            {
                engineListComboBox.setSelectedItem(rop);
            }
            else
            {
                engineListComboBox.setSelectedItem(ro[0]);
            }
        }
        else if (!modeBits.get(PropertySheet.STAND_ALONE_MODE))
        {
            if (SelectionCoordinator.getSelectedProxy().getParent() != null)
            {
	       RepositoryObjectProxy sproxy = SelectionCoordinator.getSelectedProxy().getParent();
	       engineListComboBox.addItem(sproxy);
	       engineListComboBox.setSelectedItem(sproxy);
	    }
	    else
	    {
	       RepositoryObjectProxy tempproxy = SelectionCoordinator.getSelectedProxy();
	       engineListComboBox.addItem (tempproxy);
	       engineListComboBox.setSelectedItem (tempproxy);
	    }
        }



        // App Server Choices
        vhro = Utils.getAllObjectsOfType("com.ibm.ejs.sm.beans.VirtualHost");
        if (vhro == null || vhro.length == 0)
        {
            if (!modeBits.get(TASK_MODE))
            {
                showError("No Virtual Hosts found");
                return;
            }
        }
        vh = new String[vhro.length];
        for (int i = 0 ;i < vhro.length; i++)
        {
            vh[i] = vhro[i].toString();
            virtualHostComboBox.addItem(vhro[i].toString());
        }

        if (modeBits.get(BasePropertySheet.CREATE_MODE)&& !modeBits.get(BasePropertySheet.MODEL_MODE))
        {
            virtualHostComboBox.setSelectedIndex(0);
        }

        reflectAttributes();
        layoutPanel();
        Tr.exit(tc, "createComponents");
    }       


    private void layoutPanel() {
        Tr.entry(tc, "createComponents");
        clearPanel();
        setUpGUI();
        validate();
        repaint();
        Tr.exit(tc, "createComponents");
    }

    public PropPanel getGeneralPanel() {
        Tr.entry(tc, "getGeneralPanel");
        PropPanel generalPropsPanel = super.getGeneralPanel();
        gbc = generalPropsPanel.gbc;
        gridy = gbc.gridy;
        gbc.anchor = GridBagConstraints.NORTH;
        gbc.fill = GridBagConstraints.HORIZONTAL;

        /*
          * setup General
       */
        if (modeBits.get(EDIT_MODE) || 
            modeBits.get(CONTENT_PANE_MODE))
        {
            gridy++;
            gbc.gridx=0;gbc.gridy=gridy;
            generalPropsPanel.add(enabledL,gbc);
            gbc.gridx=1;
            generalPropsPanel.add(enabledStringL,gbc);

        }

        /*		  if ((!modeBits.get(PropertySheet.EDIT_DEFAULTS_MODE)) && (!modeBits.get(PropertySheet.STAND_ALONE_MODE)) &&  (!modeBits.get(MODEL_MODE))){
                    gridy++;
                    gbc.gridx=0;gbc.gridy=gridy;
                    generalPropsPanel.add(engineNameL,gbc);
                    gbc.gridx=1;
                    generalPropsPanel.add(engineListComboBox,gbc);
                    } */

        gridy++;
        gbc.gridx=0;gbc.gridy=gridy;
        generalPropsPanel.add(descriptionL,gbc);
        gbc.gridx=1;
        gbc.weightx=1;
        generalPropsPanel.add(descriptionT,gbc);
        gbc.weightx=0;


        if (!modeBits.get(PropertySheet.EDIT_DEFAULTS_MODE))
        {
            gridy++;
            gbc.gridx=0;gbc.gridy=gridy;
            generalPropsPanel.add(virtualHostL,gbc);
            gbc.gridx=1;
            gbc.weightx=1;
            generalPropsPanel.add(virtualHostComboBox,gbc);
            gbc.weightx=0;
        }

        if (modeBits.get(EDIT_MODE) || 
            modeBits.get(CONTENT_PANE_MODE))
        {
            gridy++;
            gbc.gridx=0;gbc.gridy=gridy;
            generalPropsPanel.add(virtualHostActiveL,gbc);
            gbc.gridx=1;
            generalPropsPanel.add(virtualHostActiveT,gbc);
        }

        if (!modeBits.get(PropertySheet.EDIT_DEFAULTS_MODE))
        {
            gridy++;
            gbc.gridx=0;gbc.gridy=gridy;
            generalPropsPanel.add(uriL,gbc);
            gbc.gridx=1;
            gbc.weightx=1;
            generalPropsPanel.add(uriT,gbc);
            gbc.weightx=0;
        }

        if (modeBits.get(EDIT_MODE) || 
            modeBits.get(CONTENT_PANE_MODE))
        {
            gridy++;
            gbc.gridx=0;gbc.gridy=gridy;
            generalPropsPanel.add(uriActiveL,gbc);
            gbc.gridx=1;
            generalPropsPanel.add(uriActiveT,gbc);
        }
        Tr.exit(tc, "getGeneralPanel");
        return generalPropsPanel;
    }

    public PropPanel getAdvancedPanel() {
        Tr.entry(tc, "getAdvancedPanel");
        PropPanel advancedPropsPanel = new PropPanel();
        GridBagConstraints gbc = advancedPropsPanel.gbc = new GridBagConstraints();
        GridBagLayout gbl = new GridBagLayout();
        JScrollPane scrollpane;
        gbc.insets = new Insets(4,4,4,4);

        /**
         * setup advanced props
         */
        gridy = 0 ;
        gbc.insets = new Insets(4,4,4,4);
        gbc.anchor = GridBagConstraints.WEST;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        advancedPropsPanel.setLayout(gbl);


        gridy++;
        gbc.gridx=0;gbc.gridy=gridy;
        advancedPropsPanel.add(docRootL,gbc);
        gbc.gridx=1;
        gbc.weightx=1;
        advancedPropsPanel.add(docRootT,gbc);
        gbc.weightx=0;

        if (modeBits.get(EDIT_MODE) || 
            modeBits.get(CONTENT_PANE_MODE))
        {
            gridy++;
            gbc.gridx=0;gbc.gridy=gridy;
            advancedPropsPanel.add(docRootActiveL,gbc);
            gbc.gridx=1;
            advancedPropsPanel.add(docRootActiveT,gbc);
        }

        gridy++;
        gbc.gridx=0;gbc.gridy=gridy;
        gbc.gridwidth=2;
        advancedPropsPanel.add(classPathPanel,gbc);
        gbc.gridwidth=1;

        if (modeBits.get(EDIT_MODE) || 
            modeBits.get(CONTENT_PANE_MODE))
        {
            gridy++;
            gbc.gridx=0;gbc.gridy=gridy;
            gbc.gridwidth=2;
            scrollpane = new JScrollPane(classPathActiveVE);
            advancedPropsPanel.add(scrollpane,gbc);
            gbc.gridwidth=1;
        }


        // don't display this if in the task, since it can't be changed there
        if (!modeBits.get(TASK_MODE))
        {
            gridy++;
            gbc.gridx=0;gbc.gridy=gridy;
            advancedPropsPanel.add(errorPageL,gbc);
            gbc.gridx=1;
            advancedPropsPanel.add(errorPageT,gbc);
        }

        if (modeBits.get(EDIT_MODE) || 
            modeBits.get(CONTENT_PANE_MODE))
        {
            gridy++;
            gbc.gridx=0;gbc.gridy=gridy;
            advancedPropsPanel.add(errorPageActiveL,gbc);
            gbc.gridx=1;
            advancedPropsPanel.add(errorPageActiveT,gbc);
        }


        if (!modeBits.get(CREATE_MODE))
        {
            gridy++;
            gbc.gridx=0;gbc.gridy=gridy;
            advancedPropsPanel.add(filterListL,gbc);
            gbc.gridx=1;
            scrollpane = new JScrollPane(filterListPE);          
            advancedPropsPanel.add(scrollpane,gbc);
        }

        if (modeBits.get(EDIT_MODE) || 
            modeBits.get(CONTENT_PANE_MODE))
        {
            gridy++;
            gbc.gridx=0;gbc.gridy=gridy;
            advancedPropsPanel.add(filterListActiveL,gbc);
            gbc.gridx=1;
            scrollpane = new JScrollPane(filterListActivePE);         
            advancedPropsPanel.add(scrollpane,gbc);
        }


        gridy++;
        gbc.gridx=0;gbc.gridy=gridy;
        advancedPropsPanel.add(attributesL,gbc);
        gbc.gridx=1;
        scrollpane = new JScrollPane(attributesPE);         
        advancedPropsPanel.add(scrollpane,gbc);

        if (modeBits.get(EDIT_MODE) || 
            modeBits.get(CONTENT_PANE_MODE))
        {
            gridy++;
            gbc.gridx=0;gbc.gridy=gridy;
            advancedPropsPanel.add(attributesActiveL,gbc);
            gbc.gridx=1;
            scrollpane = new JScrollPane(attributesActivePE);         
            advancedPropsPanel.add(scrollpane,gbc);
        }

        gridy++;
        gbc.gridx=0;gbc.gridy=gridy;
        advancedPropsPanel.add(reloadIntervalL,gbc);
        gbc.gridx=1;
        gbc.weightx=1;
        advancedPropsPanel.add(reloadIntervalT,gbc);
        gbc.weightx=0;

        if (modeBits.get(EDIT_MODE) || 
            modeBits.get(CONTENT_PANE_MODE))
        {
            gridy++;
            gbc.gridx=0;gbc.gridy=gridy;
            advancedPropsPanel.add(reloadIntervalActiveL,gbc);
            gbc.gridx=1;
            advancedPropsPanel.add(reloadIntervalActiveT,gbc);
        }


        gridy++;
        gbc.gridx=0;gbc.gridy=gridy;
        advancedPropsPanel.add(autoReloadL,gbc);
        gbc.gridx=1;
        advancedPropsPanel.add(autoReloadComboBox,gbc);


        if (modeBits.get(EDIT_MODE) || 
            modeBits.get(CONTENT_PANE_MODE))
        {
            gridy++;
            gbc.gridx=0;gbc.gridy=gridy;
            advancedPropsPanel.add(autoReloadActiveL,gbc);
            gbc.gridx=1;
            advancedPropsPanel.add(autoReloadActiveT,gbc);
        }

        GridBagConstraints scgbc = new GridBagConstraints();
        GridBagLayout scgbl = new GridBagLayout();
        int scgridy=0;
        scgbc.fill = GridBagConstraints.HORIZONTAL;
        scgbc.anchor = GridBagConstraints.NORTH;
        scgbc.insets = new Insets(4,4,4,4);
        sharedContextPanel.setLayout(scgbl);

        scgbc.gridx=0;scgbc.gridy=scgridy;
        sharedContextPanel.add(sharedContextL,scgbc);
        scgbc.gridx=1;
        sharedContextPanel.add(sharedContextComboBox,scgbc);

        scgridy++;
        scgbc.gridx=0;scgbc.gridy=scgridy;
        sharedContextPanel.add(sharedContextDataSourceL,scgbc);
        scgbc.gridx=1;
        sharedContextPanel.add(sharedContextDataSourceT,scgbc);

        gridy++;
        gbc.gridwidth=2;
        gbc.gridx=0;gbc.gridy=gridy;
        advancedPropsPanel.add(sharedContextPanel,gbc);

        gbc.gridwidth=1;

        if (modeBits.get(EDIT_MODE) || 
            modeBits.get(CONTENT_PANE_MODE))
        {
            gridy++;
            gbc.gridx=0;gbc.gridy=gridy;
            advancedPropsPanel.add(sharedContextActiveL,gbc);
            gbc.gridx=1;
            advancedPropsPanel.add(sharedContextActiveT,gbc);
            gridy++;
            gbc.gridx=0;gbc.gridy=gridy;
            advancedPropsPanel.add(sharedContextDataSourceActiveL,gbc);
            gbc.gridx=1;
            advancedPropsPanel.add(sharedContextDataSourceActiveT,gbc);
        }

        Tr.exit(tc, "getAdvancedPanel");
        return advancedPropsPanel;
    }

    protected JPanel getContainmentInfoPanel() {

        if (getSelectedServletEngine() != null)
        {
            return null;
        }
        if (modeBits.get(MODEL_MODE) && modeBits.get(CREATE_MODE))
            return super.getContainmentTreePanel(TypeObject.findTypeObject(modelTypeName));
        else
        {
            return  super.getContainmentTreePanel(TypeObject.findTypeObject(servletEngineTypeName));
        }
    }

    private RepositoryObjectProxy getSelectedServletEngine() {
        RepositoryObjectProxy proxy = SelectionCoordinator.getSelectedProxy();
        if (proxy == null)
            return null;
        if (proxy.getREJB() instanceof ServletEngine)
        {
            return proxy;
        }
        return null;
    }


    public void modifyAttributes() {
        Tr.entry(tc, "modifyAttributes");
        servletGroup = (TypeInstance)SelectionCoordinator.getSelectedProxy();
        if (modeBits.get(MODEL_MODE))
        {
            super.modifyAttributes();
        }
        else
        {
            ServletGroupAttributes newAttrs = (ServletGroupAttributes)getAttributes();
            if (newAttrs == null) return;
            if (dirtyURI)
            {
                CW myCmdwatcher = new CW(new ModifyAttributesCommand(servletGroup, initialAttributes, newAttrs));
            }
            else
            {
                if ((modeBits.get(EDIT_MODE)) || (modeBits.get(CONTENT_PANE_MODE)))
                {
                    new ModifyAttributesCommand(servletGroup, initialAttributes, newAttrs);
                }
                else
                {
                    new ModifyAttributesCommand(to, newAttrs);
                }
            }
        }
        Tr.exit(tc, "modifyAttributes");
    }
    public class CW implements CommandListener
    {
        private AbstractCommand cmd;


        CW(AbstractCommand cmd) {
            CommandManager.addCommandListener(this);
            this.cmd = cmd;
        }

        public void commandComplete(CommandEvent evt) {
            Tr.entry(tc,"commandComplete",evt);         
            if (evt.getCommand().equals(cmd))
            {
                if (evt.getStatus() == CommandStatus.SUCCESS)
                {
                    // uris were dirty refresh below here and the URI tree
                    if (dirtyURI)
                    {
                        RepositoryModel rmodel = RepositoryClient.sharedInstance().getRepositoryModel();
                        try
                        {
                            if (servletGroup != null)
                            {
                                rmodel.refreshFrom(servletGroup);
                                TypeInstance vh = (TypeInstance)vhro[virtualHostComboBox.getSelectedIndex()];
                                rmodel.refreshFrom(vh);
                                dirtyURI = false;
                            }
                        }
                        catch (Exception e)
                        {
                            e.printStackTrace();
                        }
                    }
                }
                CommandManager.removeCommandListener(this);
            }
            Tr.exit(tc,"commandComplete");          
        }

        public void commandStarted(CommandEvent evt) {}

        public void commandProgress(CommandEvent evt) {}
    }

    public void modify(Attributes initialAttrs) {
        Tr.entry(tc, "modify",initialAttrs);
        servletGroup = (TypeInstance)SelectionCoordinator.getSelectedProxy();
        ServletGroupAttributes newAttrs = (ServletGroupAttributes)getAttributes();
        if (newAttrs == null) return;
        if (modeBits.get(EDIT_MODE) ||
            modeBits.get(CONTENT_PANE_MODE))
        {
            new ModifyAttributesCommand(servletGroup, initialAttributes, newAttrs);
        }
        else
        {
            new ModifyAttributesCommand(ejbType, newAttrs);
        }
        Tr.exit(tc, "modify",newAttrs);
    }


    public void reset(boolean remotely) {
        Tr.entry(tc,"reset");
        if (modeBits.get(MODEL_MODE))
        {
            modelPanel.reset(remotely);
            mattrs = (ModelAttributes) resetAttributes(cattrs, remotely);
            try
            {
                liveAttributes = cattrs = 
                                 (ServletGroupAttributes) mattrs.getAttributes();
            }
            catch (Exception e)
            {
                Tr.warning(tc, 
                           "Encountered an error in getting model attributes for " +
                           "Web Application {0}", new Object[] {e});
            }
        }
        else
        {
            liveAttributes = cattrs = 
                             (ServletGroupAttributes)resetAttributes(cattrs, remotely);
        }
        reflectAttributes();
        revalidate();
        repaint();
        Tr.exit(tc,"reset");
    }

    public Attributes getAttributes() {
        Tr.entry(tc, "getAttributes");
        if ((modeBits.get( CREATE_MODE))|| (modeBits.get(TASK_MODE)))
            cattrs = new ServletGroupAttributes();
        Tr.exit(tc, "getAttributes");
        return getAttributesFromGUI();
    }



    private ServletGroupAttributes getAttributesFromGUI() {
        Tr.entry(tc, "getAttributesFromGUI");
        name = getGroupName();
        if (name == null || name.equals(""))
        {
          if (!(modeBits.get(EDIT_DEFAULTS_MODE)|| modeBits.get(MODEL_MODE)))
          {
            showError(labelNLS.getString("servletgroup.group.entername","Please Enter a Valid Name"));
            Tr.exit(tc, "getAttributesFromGUI");
            return null;
          }
        }
        else if (!modeBits.get(EDIT_DEFAULTS_MODE))
        {
            cattrs.setName(getGroupName());
        }

        if (modeBits.get(EDIT_DEFAULTS_MODE))
        {
            cattrs = new ServletGroupAttributes();
        }


        cattrs.setDescription(descriptionT.getText());
        cattrs.setDocRoot(docRootT.getText());
        cattrs.setClasspath(classPathVE.getValuesAsVector());
        cattrs.setErrorPage(errorPageT.getText());
        cattrs.setGroupAttributes(attributesPE.getValues());
        cattrs.setFilterList(filterListPE.getValues());

        String reloadInterval = reloadIntervalT.getText();
        int reloadInt;
        if (reloadInterval != null)
        {
            try
            {
                reloadInt = Integer.parseInt(reloadInterval);
                cattrs.setReloadInterval(reloadInt);
            }
            catch (Exception e)
            {
                showError(labelNLS.getString("servletgroup.reloadinterval.error","Please enter a numeric value for the reload interval"));
                return null;
            }
        }
        cattrs.setAutoReload(autoReloadComboBox.getSelectedItem().equals(labelNLS.getString("any.true.label","True")));

        if (!modeBits.get(EDIT_DEFAULTS_MODE))
        {
            cattrs.setURIPath(getURI());
        }

        boolean sharedContextEnabled  = sharedContextComboBox.getSelectedItem().equals(labelNLS.getString("any.true.label","True"));
        cattrs.setSharedContext(sharedContextEnabled);
        if (sharedContextEnabled)
        {
            String dataSource = (String) getDataSourceName();
            if (dataSource != null)
            {
                cattrs.setSharedContextJNDIName(dataSource);
            }
        }

        Tr.exit(tc, "getAttributesFromGUI");
        return cattrs;
    }

    public String getDataSourceName () {
        return sharedContextDataSourceT.getText();
    }

    public String getURI() {
        String vh = virtualHostComboBox.getSelectedItem().toString();
        if (uriT.getText().startsWith("/"))
        {
            return vh+uriT.getText();
        }
        else
        {
            return vh+"/"+uriT.getText();
        }
    }

    private Object getEngineSelection() {
        if (isValidParentSelected())
        {
            TypeInstance sproxy = getParentSelection();
            return sproxy;
        }
        else
        {
            return null;
        }
    }


    public String getGroupName(){
        return nameTextField.getText();
    }


    public void setGroupName(String s){
        nameTextField.setText(s);
    }

    public ServletEngine getServletEngine() {
        if (isValidParentSelected())
        {
            RepositoryObjectProxy rop = (RepositoryObjectProxy) getEngineSelection();
            ServletEngine engine = (ServletEngine) rop.getREJB();
            return engine;
        }
        else
        {
            String servletEngineStr = namesNLS.getString("ServletEngine","ServletEngine");
            String servletGroupStr = namesNLS.getString("ServletGroup",
                                                        "WebApplication");
            Object nlsArgs[] = {servletEngineStr,servletGroupStr};
            String errStr = messagesNLS.getFormattedMessage
                            ("actionHandler.parentNotChosen.a.a",
                             nlsArgs,
                             "You must choose a " + servletEngineStr + 
                             " from the Parent tab before creating a " +
                             servletGroupStr + " .");
            showError(errStr);
            return null;
        }
    }

    /*
   private Object getDataSourceSelection() {
       return sharedContextDataSourceComboBox.getSelectedItem();
   }

   public DataSource getDataSource() {
       RepositoryObjectProxy rop = (RepositoryObjectProxy) getDataSourceSelection();
       DataSource dataSource = (DataSource) rop.getREJB();
       return dataSource;
   }
    */

    public ServletGroup getServletGroup() {
        return(ServletGroup)servletGroup.getREJB();
    }

    public void actionPerformed(ActionEvent e) {
        Tr.entry(tc, "actionPerfored",e);
        if (e.getActionCommand().equals("SharedContext"))
        {
            if (sharedContextComboBox.getSelectedItem().toString().equals(labelNLS.getString("any.true.label","True")))
            {
                sharedContextDataSourceT.setEnabled(true);
            }
            else
            {
                sharedContextDataSourceT.setEnabled(true);
            }
            //					 if ( populateSharedContext()) {
            //					  sharedContextDataSourceComboBox.setEnabled(true);
            ///					 } else {
            //						  EJSConsoleDialog.showInfo(labelNLS.getString("servletgroup.datasource.pleasecreate", "Please Create a Data Source"));
            //						  sharedContextDataSourceComboBox.setEnabled(false);
            //						  sharedContextComboBox.setSelectedItem(labelNLS.getString("any.false.label", "False"));
            //					 }
            //				}else {
            //					 sharedContextDataSourceComboBox.setEnabled(false);
            //				}
        }
        else if (e.getActionCommand().equals("VirtualHost"))
        {
            selectedVirtualHost = virtualHostComboBox.getSelectedItem().toString();
            defaultVHName = selectedVirtualHost;
            setupDefaults();
        }
        Tr.exit(tc, "actionPerformed");
    }

    /*
    public boolean populateSharedContext() {
         Tr.entry(tc, "populateSharedContext");
         RepositoryObjectProxy[] ro = Utils.getAllObjectsOfType("com.ibm.ejs.sm.beans.DataSource");
         if (ro != null && ro.length > 0) {
               for (int i = 0 ;i < ro.length; i++) {
                    sharedContextDataSourceComboBox.addItem(ro[i]);
               }
               Tr.exit(tc, "populateSharedContext");
               sharedContextDataSourceComboBox.setSelectedItem(ro[0]);
               return true;
         } else {
               Tr.exit(tc, "populateSharedContext");
               return false;
         }

    }
    */
    protected void reflectAttributes() {
        Tr.entry(tc, "reflectAttributes");
        super.reflectAttributes();

        if (cattrs == null)
        {
            return;
        }


        if (modeBits.get(EDIT_DEFAULTS_MODE))
        {
            virtualHostComboBox.setEnabled(false);
            nameTextField.setEnabled(false);
            uriT.setEnabled(false);
        }
        else
        {
            nameTextField.addKeyListener(new KeyAdapter() {
                                             public void keyReleased(KeyEvent e) {
                                                 setupDefaults();
                                             }
                                         });
        }

        try
        {
            boolean enabled = cattrs.getEnabled();
            if (!enabled)
            {
                enabledStringL.setText(labelNLS.getString("any.false.label","False"));
            }
            else
            {
                enabledStringL.setText(labelNLS.getString("any.true.label","True"));
            }
        }
        catch (AttributeNotSetException anse)
        {
            enabledStringL.setText(labelNLS.getString("any.false.label","False"));
        }
        enabledStringL.setForeground(UIConstants.activeAttrColor);

        Vector v;
        try
        {
            descriptionT.setText(cattrs.getDescription());
        }
        catch (AttributeNotSetException anse)
        {
        }

        try
        {
            docRootT.setText(cattrs.getDocRoot());
        }
        catch (AttributeNotSetException anse)
        {
        }

        try
        {
            String uri = cattrs.getURIPath();
            String vh = getVirtualHostName(uri);
            if (vh != null)
            {
                virtualHostComboBox.setSelectedItem(vh);
            }
            String uriS = getURIString(uri);
            if (uriS != null)
            {
                uriT.setText(uriS);
                initialURI= uriS;
            }
        }
        catch (AttributeNotSetException anse)
        {
        }

        try
        {
            classPathVE.setValues(cattrs.getClasspath());
        }
        catch (AttributeNotSetException anse)
        {
            classPathVE.setValues(new Vector());
        }

        try
        {
            errorPageT.setText(cattrs.getErrorPage());
        }
        catch (AttributeNotSetException anse)
        {
        }
        try
        {
            attributesPE.setValues(cattrs.getGroupAttributes());
        }
        catch (AttributeNotSetException anse)
        {
        }
        try
        {
            filterListPE.setValues(cattrs.getFilterList());
        }
        catch (AttributeNotSetException anse)
        {
        }

        try
        {
            reloadIntervalT.setText(new Integer(cattrs.getReloadInterval()).toString());
        }
        catch (AttributeNotSetException anse)
        {
        }


        try
        {
            if (cattrs.getAutoReload() == false)
            {
                autoReloadComboBox.setSelectedItem(labelNLS.getString("any.false.label", "False"));
            }
            else
            {
                autoReloadComboBox.setSelectedItem(labelNLS.getString("any.true.label", "True"));
            }
        }
        catch (AttributeNotSetException anse)
        {
            autoReloadComboBox.setSelectedItem(labelNLS.getString("any.true.label", "True"));
        }


        try
        {
            if (cattrs.getSharedContext() == false)
            {
                sharedContextComboBox.setSelectedItem(labelNLS.getString("any.false.label", "False"));
                //					 sharedContextDataSourceComboBox.setEnabled(false);
                sharedContextDataSourceT.setEnabled(false);
            }
            else
            {
                sharedContextComboBox.setSelectedItem(labelNLS.getString("any.true.label", "True"));
                //					 sharedContextDataSourceComboBox.setEnabled(true);
                sharedContextDataSourceT.setEnabled(true);
            }
        }
        catch (AttributeNotSetException anse)
        {
            sharedContextComboBox.setSelectedItem(labelNLS.getString("any.false.label", "False"));
            sharedContextDataSourceT.setEnabled(false);
            //				sharedContextDataSourceComboBox.setEnabled(false);
        }

        if (modeBits.get(EDIT_MODE) || 
            modeBits.get(CONTENT_PANE_MODE))
        {
            try
            {
                String uri = cattrs.getURIPathActive();
                String vh = getVirtualHostName(uri);
                String uriS = getURIString(uri);
                if ( vh != null)
                {
                    virtualHostActiveT.setText(vh);
                }
                if (uriS != null)
                {
                    uriActiveT.setText(uriS);
                }
            }
            catch (AttributeNotSetException anse)
            {
                uriActiveT.setText(labelNLS.getString("propertySheet.attributeNotSet","Attribute not set"));
            }
            try
            {
                String docRoot = cattrs.getDocRootActive();
                docRootActiveT.setText(docRoot);
            }
            catch (AttributeNotSetException anse)
            {
            }
            try
            {
                v = cattrs.getClasspathActive();
                classPathActiveVE.setValues(v);
            }
            catch (AttributeNotSetException anse)
            {
                classPathActiveVE.setValues(new Vector());
            }
            try
            {
                String errorPage = cattrs.getErrorPageActive();
                errorPageActiveT.setText(errorPage);
            }
            catch (AttributeNotSetException anse)
            {
                errorPageActiveT.setText(labelNLS.getString("propertySheet.attributeNotSet","Attribute not set"));
            }
            try
            {
                Hashtable h = cattrs.getGroupAttributes();
                attributesActivePE.setValues(h);
            }
            catch (AttributeNotSetException anse)
            {
                attributesActivePE.setValues(new Hashtable());
            }
            try
            {
                Hashtable h = cattrs.getFilterListActive();
                filterListActivePE.setValues(h);
            }
            catch (AttributeNotSetException anse)
            {
                filterListActivePE.setValues(new Hashtable());
            }

            try
            {
                reloadIntervalActiveT.setText(new Integer(cattrs.getReloadIntervalActive()).toString());
            }
            catch (AttributeNotSetException anse)
            {
            }

            try
            {
                boolean autoRel = cattrs.getAutoReload();
                if (autoRel)
                {
                    autoReloadActiveT.setText(labelNLS.getString("any.true.label","True"));
                }
                else
                {
                    autoReloadActiveT.setText(labelNLS.getString("any.false.label","False"));
                }
            }
            catch (AttributeNotSetException anse)
            {
                autoReloadActiveL.setText(labelNLS.getString("any.false.label","False"));
            }

            try
            {
                boolean sharedContext = cattrs.getSharedContext();
                if (sharedContext)
                {
                    sharedContextActiveT.setText(labelNLS.getString("any.true.label","True"));
                }
                else
                {
                    sharedContextActiveT.setText(labelNLS.getString("any.false.label","False"));
                }
            }
            catch (AttributeNotSetException anse)
            {
                sharedContextActiveT.setText(labelNLS.getString("any.false.label","False"));
            }

            try
            {
                // DataSource Fixes needed here
                //					 String ds = cattrs.getDataSourceIOR();
                String sc = cattrs.getSharedContextJNDIName();
                if (sc!= null)
                {
                    sharedContextDataSourceActiveT.setText(sc);
                }
                else
                {
                    sharedContextDataSourceActiveT.setText(notSetString);
                }
            }
            catch (AttributeNotSetException re)
            {
                sharedContextDataSourceActiveT.setText(notSetString);
            }
        }
        if (modeBits.get( BasePropertySheet.CREATE_MODE) || modeBits.get( BasePropertySheet.TASK_MODE))
        {
            engineListComboBox.setEditable(false);
        }
        else
        {
            engineListComboBox.setEditable(false);
            engineListComboBox.setEnabled(false);
        }

        /*
        if ((!modeBits.get(BasePropertySheet.EDIT_DEFAULTS_MODE)) && (!modeBits.get(BasePropertySheet.CREATE_MODE)) ){
              try {
                   String path = cattrs.getURI();
                   uriT.setText(getURIString(path));
                   virtualHostComboBox.setSelectedItem(getURIString(path));
              } catch (AttributeNotSetException re) {
                   uriT.setText("");
              }
        }
        */

        if (modeBits.get(BasePropertySheet.CREATE_MODE))
        {
            setupDefaults();
        }

        if ( modeBits.get(BasePropertySheet.READ_ONLY_MODE))
        {
            descriptionT.setEditable(false);
            docRootT.setEditable(false);
            uriT.setEditable(false);
            virtualHostComboBox.setEditable(false);
            errorPageT.setEditable(false);
            autoReloadComboBox.setEnabled(false);
            autoReloadComboBox.setEditable(false);
            upButton.setEnabled(false);
            browseButton.setEnabled(false);
            downButton.setEnabled(false);
            deleteButton.setEnabled(false);
        }
        Tr.exit(tc, "reflectAttributes");
        return;
    }

    public String getVirtualHostName (String uri) {
        if ((uri!= null) &&(uri.indexOf("/") >= 0))
        {
            String vh = uri.substring(0,uri.indexOf("/"));
            return vh;
        }
        else
        {
            return null;
        }
    }

    public String getURIString (String url) {
        if ((url!= null) &&(url.indexOf("/") >= 0))
        {
            return url.substring(url.indexOf("/"),url.length());
        }
        else
        {
            return null;
        }
    }

    public void setVirtualHostName (String vhName ) {
        defaultVHName = vhName;
        boolean found = false;
        if (vh != null)
        {
            for (int i = 0;i <vh.length;i++)
            {
                if (vh[i].equals(vhName))
                {
                    found = true;
                    break;
                }
            }

        }
        if (!found)
        {
            virtualHostComboBox.addItem(vhName);
            virtualHostComboBox.setSelectedItem(vhName);
        }
        setupDefaults();
    }

    public TypeInstance getTypeInstance() {
        if (ti == null)
        {
            Object o = getEngineSelection();
            if (o instanceof TypeInstance)
            {
                ti = (TypeInstance) o;
            }
            else if (servletGroup != null)
            {
                ti = servletGroup;
            }
        }
        return ti;
    }

    public void setTypeInstance(TypeInstance ti) {
        super.setTypeInstance(ti);
        this.ti = ti;
        server_root = null;
    }

    /*
    ** Based on Server_root and the name we can come up with defaults for
    ** URI name
    ** docroot
    ** classpath
    */
    public void setupDefaults() {
        Tr.entry(tc, "setupDefaults");        

        if ((!modeBits.get(BasePropertySheet.CREATE_MODE)) && (!modeBits.get(BasePropertySheet.STAND_ALONE_MODE)))
        {
            return;
        }

        if (server_root == null)
        {
            server_root = getServerRoot(getTypeInstance());
            slash = figureOutSlash(server_root);
        }

        String name = nameTextField.getText();
        if (name.length() > 0)
        {
            // uri
            if (!uriEdited)
            {
                uriT.setText("/webapp/"+name);
            }

            // docroot
            if (!docRootEdited)
            {
                docRootT.setText(server_root+slash+"hosts"+slash+defaultVHName+slash+name+slash+"web");
            }

            Vector v = classPathVE.getValuesAsVector();

            // check to see if we've set if before
            // classpath
            String classpath;
            String newEntry = server_root+slash+"hosts"+slash+defaultVHName+slash+name+slash+"servlets";
            if (v.size() == 1)
            {
                classpath =  v.elementAt(0).toString();
                if ((classpath.indexOf("hosts"+slash)> 0) && ( (classpath.indexOf("servlets") > 0)))
                {
                    v.setElementAt(newEntry,0);
                    classPathVE.setValues(v);
                }
            }
            else if (v.size() == 0)
            {
                v.addElement(newEntry);
                classPathVE.setValues(v);
            }
        }
        Tr.exit(tc, "setupDefaults");         
    }


    // added by gary p
    // helper method to fix slashes
    private void fixSlashes(String serverRoot) {
        slash = figureOutSlash(server_root);
        String name = nameTextField.getText();
        if (name.length() > 0)
        {
            // uri
            if (!uriEdited)
            {
                uriT.setText("/webapp/"+name);
            }

            // docroot
            if (!docRootEdited)
            {
                docRootT.setText(server_root+slash+"hosts"+slash+defaultVHName+slash+name+slash+"web");
            }

            Vector v = classPathVE.getValuesAsVector();

            // check to see if we've set if before
            // classpath
            String classpath;
            String newEntry = server_root+slash+"hosts"+slash+defaultVHName+slash+name+slash+"servlets";
            if (v.size() == 1)
            {
                classpath =  v.elementAt(0).toString();
                if ((classpath.indexOf("hosts"+slash)> 0) && ( (classpath.indexOf("servlets") > 0)))
                {
                    v.setElementAt(newEntry,0);
                    classPathVE.setValues(v);
                }
            }
            else if (v.size() == 0)
            {
                v.addElement(newEntry);
                classPathVE.setValues(v);
            }
        }
    }

    // added by gary p.
    // needed to add this because tasks need to set server root 
    // after a proper servlet engine is selected
    public void setServerRoot(TypeInstance ti) {
        server_root = getServerRoot(ti);
        fixSlashes(server_root);
    }

    public static String getServerRoot(TypeInstance ti) {
        Tr.entry(tc, "getServerRoot");        
        // have to find the node
        TypeInstance node;
        TypeInstance parent=ti;
        NodeAttributes nattrs;
        String installRoot=null;

        if (ti == null)
        {
            return "/";
        }

        while (parent != null)
        {
            if (parent.getREJB() instanceof Node)
            {
                node = parent;
                nattrs = (NodeAttributes)node.getAttributes();
                try
                {
                    installRoot = nattrs.getInstallRoot();
                }
                catch (AttributeNotSetException anse)
                {
                    installRoot = null;
                }
            }
            parent = (TypeInstance)parent.getParent();
        }

        if (installRoot==null)
        {
            installRoot="/";
        }
        Tr.exit(tc, "getServerRoot");         
        return installRoot;
    }

    public String figureOutSlash(String s) {
        Tr.entry(tc, "figureOutSlash",s);         
        String forward = "/";
        String back = "\\";

        if (s ==null)
        {
            Tr.exit(tc, "figureOutSlash",forward);        
            return forward;
        }

        if ((s.indexOf(back) > -1) || (s.indexOf(":") > -1))
        {
            Tr.exit(tc, "figureOutSlash",back);       
            return back;
        }
        else
        {
            Tr.exit(tc, "figureOutSlash",forward);        
            return forward;
        }
    }

    private void adjustSize(JComboBox c) {
        Dimension d = c.getSize();
        d.setSize(FIELD_SIZE, d.height);
        c.setSize(d);
    }

    class ClassPathPanel extends JPanel implements ActionListener
    {
        public void actionPerformed (ActionEvent e) {
            Tr.entry(tc, "actionPerformed",e);        
            String command = e.getActionCommand();

            if (command.equals("Up"))
            {
                classPathVE.moveUp();
            }
            else if (command.equals("Down"))
            {
                classPathVE.moveDown();
            }
            else if (command.equals("Delete"))
            {
                classPathVE.delete();
            }
            else if (command.equals("Browse"))
            {
                String s = browse();
                if (s != null)
                {
                    if ((classPathVE.getSelectedRow() > -1) || (classPathVE.getEditingRow() > -1))
                    {
                        if (classPathVE.getEditingRow() > -1)
                        {
                            classPathVE.set(s,classPathVE.getEditingRow(),0);
                        }
                        else
                        {
                            classPathVE.set(s,classPathVE.getSelectedRow(),0);
                        }
                    }
                    else
                    {
                        Vector v = new Vector(1);
                        v.addElement(s);
                        classPathVE.insert(v);
                    }
                }
                browseButton.setSelected(false);
            }

            Tr.exit(tc, "actionPerformed");       
        }

        public String browse () {
            try
            {
                fsService = getFileBrowserServiceBean((TypeInstance)engineListComboBox.getSelectedItem());
                chooser = new BasicRemoteJFileChooser(fsService, null);
                if (lastUsedDir != null)
                {
                    try
                    {
                        chooser.setCurrentDirectory(new File(lastUsedDir));
                    }
                    catch (Exception e)
                    {
                    }
                }
                chooser.resetChoosableFileFilters();
                chooser.removeChoosableFileFilter(chooser.getAcceptAllFileFilter());
                int option = chooser.showOpenDialog(this);
                File chosen = chooser.getSelectedFile();
                if ((chosen != null)&& (option == JFileChooser.APPROVE_OPTION))
                {
                    String userChoice;
                    NodeFileSystemView myFsView = (NodeFileSystemView) chooser.getFileSystemView();
                    String separator = (String) myFsView.getFileProperty("separator", chosen);
                    userChoice = (String) myFsView.getFileProperty("AbsolutePath", chosen);
                    userChoice = userChoice.replace(File.separatorChar, separator.charAt(0));

                    if (userChoice.toString().length() > 0)
                    {
                        lastUsedDir = chosen.getParent();
                        return userChoice.toString();
                    }
                    else
                    {
                        return null;
                    }
                }
            }
            catch (RepositoryOpException roe)
            {
                Tr.warning(tc, "Cannot get a remote file browser {}", new Object[] {roe});
                ExceptionManager.handleExc(roe);
            }
            return null;
        }
    }


    private static FileBrowserService getFileBrowserServiceBean(TypeInstance ti)   throws RepositoryOpException   {
        Tr.entry(tc, "getFileBrowserServiceBean", ti);
        FileBrowserService fileBrowserService;
        Node node=null;
        TypeInstance instance = ti;

        while (instance != null)
        {
            if (instance.getREJB() instanceof Node)
            {
                node = (Node)instance.getREJB();
                break;
            }
            else
            {
                instance = (TypeInstance)instance.getParent();
            }
        }

        try
        {
            FileBrowserServiceHome fileBrowserServiceHome =
            (FileBrowserServiceHome) 
            RepositoryClient.getTaskHome("FileBrowserServiceHome");
            Tr.event(tc, "fetched FileBrowserServiceHome");
            fileBrowserService = fileBrowserServiceHome.create(node);
            Tr.event(tc, "created FileBrowserService instance");
        }
        catch (Exception e)
        {
            Tr.warning(tc, "Failed.to.get.a.FileBrowserServiceBean.session.bean.{0}", 
                       new Object[] {e});
            throw new RepositoryOpException("", e);
        }
        Tr.exit(tc, "getFileBrowserServiceBean");
        return fileBrowserService;
    }
}
