package com.ibm.ejs.sm.beans;

import java.util.*;
import java.sql.*;
import java.rmi.RemoteException;
import javax.ejb.*;
import java.io.*;
import com.ibm.ejs.ras.*;
import com.ibm.ejs.sm.exception.*;
import com.ibm.ejs.sm.active.ActiveObjectConfig;
import com.ibm.ejs.sm.active.ActiveObjectStatus;
import com.ibm.ejs.sm.active.ActiveServletConfig;
import com.ibm.ejs.sm.agent.AdminAgent;
import com.ibm.ejs.sm.agent.ParamList;
import com.ibm.ejs.sm.agent.ContainmentPath;
import com.ibm.ejs.sm.agent.ContainmentPathElem;
import com.ibm.ejs.sm.client.ui.NLS;
import com.ibm.ejs.sm.util.act.Act;
import com.ibm.ejs.sm.util.act.ActServerImpl;
import com.ibm.ejs.sm.util.db.DBMgr;
import com.ibm.ejs.sm.util.db.DBQueryResult;
import com.ibm.ejs.sm.util.Utils;

class ServletBeanHelper {
    Hashtable hashtableOfClones = new Hashtable();

    protected static boolean getDeleteFlag(Long pk,ServletBean sb) throws RemoteException {

        Boolean returnValue=new Boolean(false);

        try {
            Object value = instance.hashtableOfClones.get(pk);
            if(value==null) {
                returnValue=(Boolean)instance.initialize(pk,sb);
            } else {
                returnValue=(Boolean)value;
            }

        } catch(Exception e) {
            RemoteException r = new RemoteException("", e);
            throw r;
        }
        return returnValue.booleanValue();
    }


    protected static boolean getDeleteFlag(Long pk,ServletGroupBean sgb) throws RemoteException {

        Boolean returnValue=new Boolean(false);

        try {
            Object value = instance.hashtableOfClones.get(pk);
            if(value==null) {
                returnValue=(Boolean)instance.initialize(pk,sgb);
            } else {
                returnValue=(Boolean)value;
            }

        } catch(Exception e) {
            RemoteException r = new RemoteException("", e);
            throw r;
        }
        return returnValue.booleanValue();
    }

    private Boolean initialize(Long pk, ServletBean sb) throws RemoteException {

        Model amodel=null;
        Enumeration enum=null;
        Long deletepk =new Long(-1), pktemp_= new Long(0);
        Boolean BTrue = new Boolean(true);
        Boolean BFalse = new Boolean(false);

        Object classlock = new Object();

        synchronized (classlock) {
            try {

                amodel=sb.isAClone();

                if(amodel!=null) {
                    enum=amodel.listClones();
                }
                while(enum.hasMoreElements()) {

                    Servlet cservlet=(Servlet)enum.nextElement();
                    pktemp_=(Long)cservlet.getPrimaryKey();
                    deletepk=(deletepk.intValue() > pktemp_.intValue()) ? deletepk: pktemp_;
                    instance.hashtableOfClones.put(pktemp_,BFalse);
                }
                instance.hashtableOfClones.put(deletepk,BTrue);
            } catch(Exception e) {
                RemoteException r = new RemoteException("", e);
                throw r;

            }

        }
        return((Boolean)instance.hashtableOfClones.get(pk));
    }//end of method

    private Boolean initialize(Long pk, ServletGroupBean sgb) throws RemoteException {

        Model amodel=null;
        Enumeration enum=null;
        Long deletepk =new Long(-1), pktemp_= new Long(0);
        Boolean BTrue = new Boolean(true);
        Boolean BFalse = new Boolean(false);
        int numberOfClones=0;

        Object classlock = new Object();

        synchronized (classlock) {
            try {

                amodel=sgb.isAClone();

                if(amodel!=null) {
                    enum=amodel.listClones();
                }
                while(enum.hasMoreElements()) {
                    ++numberOfClones;

                    ServletGroup cServletGroup=(ServletGroup)enum.nextElement();

                    pktemp_=(Long)cServletGroup.getPrimaryKey();
                    deletepk=(deletepk.intValue() > pktemp_.intValue()) ? deletepk: pktemp_;
                    instance.hashtableOfClones.put(pktemp_,BFalse);
                }

                instance.hashtableOfClones.put(deletepk,BTrue);
            } catch(Exception e) {
                RemoteException r = new RemoteException("", e);
                throw r;

            }

        }
        return((Boolean)instance.hashtableOfClones.get(pk));
    }//end of method


    protected static void reSet(){
        (instance.hashtableOfClones).clear();
    }
    private static final ServletBeanHelper instance = new ServletBeanHelper();
}//end of class





